import java.util.Arrays;

public class Sort {
	public static void selectionSort(int[] arr) {
		for (int i = 0; i < arr.length; i++) {
			int min = arr[i]; // Håller reda på minsta element den osorterade delen.
			int minidx = i;   // Index för minsta element i osorterad del.
            // Inre loop går igenom resten av arr för att se om det finns något mindre element
			for (int j = i + 1; j < arr.length; j++) {
				if (arr[j] < min) { // Om vi hittar något mindre än nuvarande minimum...
					min = arr[j];   // ...updatera min och...
					minidx = j;     // ... uppdatera index för minsta element.
				}
			}
			if (minidx > i) { // Om vi hittade ett mindre elemet!
                arr[minidx] = arr[i]; // Byt plats på minsta element och arr[i]
				arr[i] = min;         // Byt plats, minsta element hamnar i sorterad del.
			}
		}
	}
	
	public static void mergeSort(int[] arr) {
		int[] temparr = new int[arr.length]; // Skapa temporär array
		mergeSort(arr, temparr, 0, arr.length - 1); // sortera hela arrayen.
		
		for (int i = 0; i < arr.length; i++) {
			arr[i] = temparr[i]; // kopiera tillbaka element i sorterad ordning
                                // från temporär array till orginalet.
		}
	}
	private static void mergeSort(int[] src, int[] dst, int start, int end) {
		if (start >= end) {  //  0 eller 1 element redan sorterade
			if (start == end) {
				dst[start] = src[start]; //"basfall" ett element att kopiera.
			}
			return;
		}

		int m = (start + end) / 2;
		mergeSort(src, dst, start, m); // sortera rekursivt från start-mitt
		mergeSort(src, dst, m + 1, end); // sortera rekursivt från mitt-slut

		for (int i = start; i <= end; i++) {
			src[i] = dst[i]; // kopiera delresultat till src.
		}
		// Nu är vänster resp. höger halva sorterade.
        
		// Nästa steg är att kombinera ihop halvorna så hela arrayen blir sorterad.
		int i1 = start, i2 = m + 1;
		int j = start;
		while (i1 <= m && i2 <= end) {
			if (src[i1] <= src[i2]) { // nästa element från vänster halva är minst
				dst[j++] = src[i1++]; // kopiera detta
			} else {                    // annars, ta nästa element från höger halva
				dst[j++] = src[i2++];   // kopiera detta till rätt plats.
			}
		}
        // Efter att endera halvan tagit slut: kopiera resten.
		while (i1 <= m) { // Kopiera resten från mindre halva
			dst[j++] = src[i1++];
		}
		while (i2 <= end) { // Annars kopierar vi resten från den större halvan.
			dst[j++] = src[i2++];
		}
	}
	
	public static void main(String[] args) {
		int[] arr = {35, 25, 21, 19, 32, 39, 36, 42, 18, 8, 5, 2, 7, 13, 10, 17};
		int[] arr2 = arr.clone();
		selectionSort(arr);
		System.out.println(Arrays.toString(arr));

		mergeSort(arr2);
		System.out.println(Arrays.toString(arr2));
	}
}
